// 解析json
function parseJson(jsonData){
    try{if(jsonData && !isJson(jsonData)) jsonData = JSON.parse(jsonData);}catch(e){}
    return jsonData;
}
//判断是否json对象
function isJson(obj){
    var isjson = typeof(obj) == "object" && Object.prototype.toString.call(obj).toLowerCase() == "[object object]" && !obj.length;
    return isjson;
}


function popupDict(b) {
    var a = b;
    if(isJson(a)){
        a = JSON.stringify(a);
    }
    try {
        dictcn.popupDict(a)
    } catch(c) {
        popupDictCallback(a)
    }
}
function popupDictCallback(a) {
    var b = parseJson(a);
    if (typeof popupDictCall == "function") {
        popupDictCall(b)
    }
};
//开始测评
function beginEvaluating(jsonData){
    jsonData = parseJson(jsonData);
    var uwid = jsonData.uwid || "";
    // console.log("uwid: "+uwid);
    try{ dictcn.beginEvaluating(JSON.stringify({'uwid':uwid, 'successCallback':'onFinishEvaluating'})); }catch(e){}
}
//结束测评回调函数
function onFinishEvaluating(jsonData){
    jsonData = parseJson(jsonData);
    var uwid = jsonData.uwid || "";
    var score = parseInt(jsonData.score);
    if(uwid){
        $.commFun.refreshEvaIcon(uwid,score);
    }
}

/* 读写localStorage数据
 * setStorage方法参数：
 * {
 * "key": " "  //键值
 * "value":   //要保存的数据
 * }
 * getStorage方法参数：
 * {
 * "key": " "  //键值 (键值为 “ paperID_* ”时，是否直接返回一组筛选后的数据？)
 * "successCallback": ""   //回调函数名
 * }
 * getStorage方法回调函数 getAllEvaRes 参数：
 * {
 * "key": "pageID_Eva_*"  //键值
 * "value": {"pageID_Eva_uwid":"{'name':'', 'score':''}","pageID_Eva_uwid":"{}","pageID_Eva_uwid":"{}","pageID_Eva_uwid":"{}",...}  //json数据
 * }
 */
function setStorage(jsonData) {
    jsonData = parseJson(jsonData);
    var key = jsonData.key || "";
    var value;
    if(isJson(jsonData.value)){
        value = JSON.stringify(jsonData.value) || "";
    }
    else {
        value = jsonData.value || "";
    }
    try{ dictcn.setItem(JSON.stringify({'key':key, 'value':value})); }catch(e){}
}
function getStorage(jsonData) {
    jsonData = parseJson(jsonData);
    var key = jsonData.key || "";
    var successCallback = jsonData.successCallback || "";
    try{ dictcn.getItem(JSON.stringify({'key':key, 'successCallback':successCallback})); }catch(e){}
}


/* 添加生词本 addScb
 * 参数格式json:
 * jsonData = {
 *     "uwid":"",                                 //uwid
 *     "source":"0/1",                            //标记单词收藏或例句收藏
 *     "keypath":"body.0.sense.6.cont.0.example.1",       //例句收藏中，例句数据的路径
 *     "parentuwid":"",       //例句收藏中，例句所属父级Uwid
 *     "successCallback":"onScbSuccess",         //成功回调函数
 * }
 */
function addScb(jsonData){
    jsonData = parseJson(jsonData);
    var uwid = jsonData.uwid || "";
    var source = jsonData.source;
    var keypath = jsonData.keypath || "";
    var parentuwid = jsonData.parentuwid || "";
    // console.log(uwid + " / "+ source + " / "+ keypath + " / "+ parentuwid)
    try{ dictcn.addScb(JSON.stringify({'uwid':uwid,'source':source,'keypath':keypath ,'parentuwid':parentuwid,'successCallback':'onScbSuccess'})); }catch(e){}
    // setTimeout(function(){ //测试代码
    //     onScbSuccess({"uwid":uwid, "in_scb": 1});
    // },500);
}
/* 生词本添加成功
 * 参数格式json:
 * jsonData = {
 *     "uwid":"",                                 //uwid
 *     "in_scb": "1/0"
 * }
 */
function onScbSuccess(jsonData){
    jsonData = parseJson(jsonData);
    var uwid = jsonData.uwid || "";
    var in_scb = jsonData.in_scb || 0;
    $.commFun.refreshStarIconStatus(uwid,in_scb);
}


/* 设置面板相关方法
 * settingDone参数格式json:
 * jsonData = {
 *     "fontSize": "10",          //字号
 *     "showCh": "1/0",          //是否显示中文
 *     "simpleColor": "1/0",       //是否采用素雅版面
 * }
 */
//打开 native 设置面板
function openSettingPanel(){
    try{ dictcn.openSettingPanel(); }catch(e){}
}
// 完成设置方法
function settingDone(jsonData){
    jsonData = parseJson(jsonData);
    $.commFun.settingRefresh(jsonData);
}
//设置面板开放native接口
//改变字体 
function changeFontSize(jsonData){
    jsonData = parseJson(jsonData);
    $('html').css('font-size',jsonData.font_size+"px");
    $.commFun.resizeSwiper();
}
//是否显示中文
function whetherShowCh(jsonData){
    jsonData = parseJson(jsonData);
    if(jsonData.showCh == "1"){
        $('.content').eq(0).removeClass('hideCh');
    }
    else if(jsonData.showCh == "0") {
        $('.content').eq(0).addClass('hideCh');
    }
    $.commFun.resizeSwiper();
}
//查词页更新中文显示状态，通知客户端同步参数接口
function changeShowChSet(jsonData){
    jsonData = parseJson(jsonData);
    var showCh = jsonData.showCh;
    // console.log(showCh)
    try{ dictcn.changeShowChSet(JSON.stringify({"showCh": showCh})); }catch(e){}
}


////////////////////////////查字////////////////////////////////////////////////////////////////////////////
/* 查字或词组模块：
*   定义 查字方法 searchText
*/
////////////////////////////查字或词组////////////////////////////////////////////////////////////////////////////
/* 查字 【重刷页面】 */
function searchText(jsonData){
    jsonData = parseJson(jsonData);
    var uwid = jsonData.uwid || ""; //要跳转的单词的uwid
    var autoUwid = jsonData.autoUwid || ""; //变位词的情况
    var senseId = jsonData.senseId || ""; //跳转到第几条释义
    var pinyin = jsonData.pinyin || "";
    var extArgu = JSON.stringify({"senseId":senseId, "pinyin":pinyin});
    // console.log("uwid: "+uwid+" / extArgu: "+extArgu);
    try{ dictcn.searchText(JSON.stringify({"uwid":uwid,"autoUwid":autoUwid,"extArgu":extArgu})); }catch(e){}
}

/* 查词组
 * 参数格式json:
 * jsonData = {
 *     uwid:"",                                 //要查询词组的uwid
 *     tplName:"",                              //模板名称
 *     successCallback:"onAjaxSuccess",
 *     failedCallback:"onAjaxFailed"
 * }
 */
function ajaxSearch(jsonData){
    jsonData = parseJson(jsonData);
    var uwid = jsonData.uwid || "";
    var tplName = jsonData.tplName || "";
    // console.log("uwid: "+uwid+" / tplName: "+tplName)
    try{ dictcn.ajaxSearch(JSON.stringify({'uwid':uwid,'tplName':tplName,'successCallback':"onAjaxSuccess",'failedCallback':"onAjaxFailed"})); }catch(e){}
    // setTimeout(function(){
    //     onAjaxSuccess(jsonDD);
        // onAjaxFailed({"uwid": uwid});
    // },10);
}
/* 查词成功
 * 参数格式json:
 * jsonData = {
 *     uwid:"",                                 //uwid
 *     htmlText:""                              //返回的html文本片段
 *     "scbStatus": {"65456595": 1, "65456596": 0, "65456597": 1, ...}       //例句收藏状态
 * }
 */
function onAjaxSuccess(jsonData){
    jsonData = parseJson(jsonData);
    var uwid = jsonData.uwid || "";
    if(uwid){
        var $aim = $("[uwid='"+uwid+"']");
        if($aim.length){
            var tabBar = $aim.find(".tabBar")[0];
            if(tabBar.delayRf){
                clearTimeout(tabBar.delayRf);
                tabBar.delayRf = null;
            }
            tabBar.webReq = null;
            $.commFun.assePhrasePage($aim, jsonData.htmlText, jsonData.scbStatus);
        }
    }
}
/* 查词失败
 * 参数格式json:
 * jsonData = {
 *     uwid:"",                                 //uwid
 *     tip:""                                  //提示信息
 * }
 */
function onAjaxFailed(jsonData){
    jsonData = parseJson(jsonData);
    var uwid = jsonData.uwid || "";
    var tip = jsonData.tip || "";
    if(uwid){
        var tabCon = $("[uwid='"+uwid+"']");
        var tabBar = tabCon.find(".tabBar")[0];
        tabBar.webReq = null;
        tabCon.addClass('failLoad');
        $(tabBar).one('click', function(){
            tabCon.removeClass('failLoad');
        });
    }
    if(tip) alert(tip);
}


//告知客户端用户选择文本
function tellSelectText(text){
    try{ dictcn.tellSelectText(JSON.stringify({'text':text})); }catch(e){}
}
 //开放给native接口，设置是否关闭上下拉刷新
 function setPullToRefresh(jsonData){
    jsonData = parseJson(jsonData);
    pubArgu.goWordLock = parseInt(jsonData.lock); //0 不锁定，1 锁定
 }

//开放给native接口，滑出webview时调用touchend事件
function swiperTouchMoveOut(){
    var swiperPages = pubArgu.swiperPages, swiperMain = pubArgu.swiperMain, swiperBody = pubArgu.swiperBody;
    if(swiperBody.width){
        var s = swiperPages[swiperBody.activeIndex];
        s.onTouchEnd(s);
    }
    else{
        swiperMain.onTouchEnd(swiperMain);
    }
}

/* 页面唤醒后更新状态方法update：
 * 参数格式json:
 * jsonData = {
 *     "scbStatus": {"65456595": 1, "65456596": 0, "65456597": 1, ...},      //收藏按钮状态
 *     "fontSize": "12",      //字体大小
 *     "simpleColor": "1/0",      //黑白配色
 * }
 */
function update(jsonData){
    jsonData = parseJson(jsonData);
    var scbStatus = jsonData.scbStatus;
    $.commFun.commSettingRefresh(jsonData); //通用设置更新页面方法
    if(scbStatus && isJson(scbStatus)){
        $.commFun.updateAllStarIconStatus(scbStatus); //刷新所有收藏按钮的状态
    }
}


/* 查看补充说明方法 viewAddsInstruction：
 * 参数格式json:
 * jsonData = {
 *     "showWay": "img/url/html/...",      //展示方式，可扩展
 *     "imglist": ["xxx1.png","xxx2.png","xxx3.png"],      //展示方式，可扩展
 *     "index": "0",      //展示从第几个开始，没有默认为零
 *     "templateName": "abbreviation_explain",      //拼装页面时的模板名称
 *     "uwid": "", //html展示时，查词uwid
 *     "title": "", //html展示时，标题栏标题
 *     "extArgu": "{}",      //拼装页面时转发的数据
 * }
 */
 function viewAddsInstruction(jsonData){
    jsonData = parseJson(jsonData);
    var showWay = jsonData.showWay || "";
    var imglist = jsonData.imglist || "";
    var index = jsonData.index || 0;
    var templateName = jsonData.templateName || "";
    var uwid = jsonData.uwid || "";
    var title = jsonData.title || "说明";
    var senseId = jsonData.senseId || "";
    var extArgu = JSON.stringify({"senseId":senseId});
    // console.log("showWay: "+showWay+ " / templateName: "+templateName+" / extArgu:"+extArgu+" / uwid:"+uwid+" / title:"+title);
    try{ dictcn.viewAddsInstruction(JSON.stringify({"showWay":showWay, "imglist":imglist, "index":index, "title":title, "templateName":templateName, "uwid":uwid, "extArgu":extArgu})); }catch(e){}
 }

 /* 向客户端请求播放链接（权限由客户端直接控制）
 * requestAudioUrl参数格式json:
 * jsonData = {
 *     "name": "xxx.mp3",      //音频的name
 *     "type": 1/2,      //请求音频的类型，1为单词或例句发音，2为用户语音评测录音
 *     "lang": "",      //lang
 *     "uwid": "9546528443",      //按钮对象所属uwid
 *     "classname": "playSound",      //按钮对象的类名
 *     "bodyIndex": "0/1/2",      //多音字序列
 *     "objIndex": "1/2/3/...",      //播放对象序列
 * }
 * 成功回调函数onRequestAudioUrlSuccess参数格式json:
 * jsonData = {
 *     "url": "",      //音频的url
 *     "type": 1/2,      //请求音频的类型，1为单词或例句发音，2为用户语音评测录音
 *     "uwid": "9546528443",      //按钮对象所属uwid
 *     "classname": "playSound",      //按钮对象的类名
 *     "bodyIndex": "0/1/2",      //多音字序列
 *     "objIndex": "1/2/3/...",      //播放对象序列
 * }
 * 失败回调函数onRequestAudioUrlFailed参数格式json:
 * jsonData = {
 *     "errCode": "1/2/3/...",      //约定的错误码(1为网络请求超时，2为音频文件丢失，3为无播放权限)
 *     "message": "音频文件丢失...",      //可供显示的错误提示
 *     "type": 1/2,      //请求音频的类型，1为单词或例句发音，2为用户语音评测录音
 *     "uwid": "9546528443",      //按钮对象所属uwid
 *     "classname": "playSound",      //按钮对象的类名
 *     "bodyIndex": "0/1/2",      //多音字序列
 *     "objIndex": "1/2/3/...",      //播放对象序列
 * }
 */
 //请求播放链接方法
 function requestAudioUrl(jsonData){
    jsonData = parseJson(jsonData);
    var name = jsonData.name || "";
    var type = jsonData.type || "";
    var lang = jsonData.lang || "";
    var uwid = jsonData.uwid || "";
    var classname = jsonData.classname || "";
    var bodyIndex = jsonData.bodyIndex > -1 ? jsonData.bodyIndex : "-1";
    var objIndex = jsonData.objIndex || "";
    // console.log("name: "+ name + " /type: " + type + " /lang: "+ lang + " /uwid: "+ uwid + " /classname: "+ classname + " /bodyIndex: "+ bodyIndex +" /objIndex: "+ objIndex);
    try{ dictcn.requestAudioUrl(JSON.stringify({"name":name, "type":type, "uwid":uwid, "lang":lang, "classname":classname, "bodyIndex":bodyIndex, "objIndex":objIndex, "successCallback":"onRequestAudioUrlSuccess", "failedCallback":"onRequestAudioUrlFailed"})); }catch(e){}
    // setTimeout(function(){ //测试代码
        // onRequestAudioUrlSuccess({"url":"./testAsset/kca05_kcb05.mp3", "type":type, "uwid":uwid, "classname":classname, "bodyIndex":bodyIndex, "objIndex":objIndex});
    //     onRequestAudioUrlFailed({"type":type, "uwid":uwid, "classname":classname, "errCode":1, "bodyIndex":bodyIndex, "objIndex":objIndex, "message":"录音文件丢失"});
    // },500);
 }
 //成功回调函数
 function onRequestAudioUrlSuccess(jsonData){
    jsonData = parseJson(jsonData);
    var url = jsonData.url;
    var uwid = jsonData.uwid;
    var classname = jsonData.classname;
    var type = jsonData.type;
    var bodyIndex = jsonData.bodyIndex;
    var objIndex = jsonData.objIndex ? (jsonData.objIndex - 1) : 0;
    var $startNode = $("body");
    if(bodyIndex > -1){
        $startNode = $(pubArgu.swiperBody.slides[bodyIndex]).find(".content");
    }
    if($startNode.find('[uwid="'+uwid+'"]').find('.'+classname)[objIndex] == pubArgu.listenVoiceObj){ //对象比对成功，调用播放器开始播放
        var $lVO = $(pubArgu.listenVoiceObj);
        if(type == 1){
            $lVO.audioPlayer({"url":url, "autoPlay":1, "callbackType":5});
        }
        else if(type == 2){
            $lVO.audioPlayer({"url":url, "autoPlay":1, "callbackType":6});
        }
    }
 }
 //失败回调函数
 function onRequestAudioUrlFailed(jsonData){
    jsonData = parseJson(jsonData);
    var uwid = jsonData.uwid;
    var classname = jsonData.classname;
    var type = jsonData.type;
    var errCode = jsonData.errCode;
    var message = jsonData.message;
    var bodyIndex = jsonData.bodyIndex;
    var objIndex = jsonData.objIndex ? (jsonData.objIndex - 1) : 0;
    var $startNode = $("body");
    if(bodyIndex > -1){
        $startNode = $(pubArgu.swiperBody.slides[bodyIndex]).find(".content");
    }
    if($startNode.find('[uwid="'+uwid+'"]').find('.'+classname)[objIndex] == pubArgu.listenVoiceObj){ //对象比对成功，开始错误处理
        if(type == 1){ //单词或例句发音
            if(errCode == 1 || errCode == 3){ //网络超时 or 没权限
                $(pubArgu.listenVoiceObj).removeClass('loading');
            }
        }
        else if(type ==2){ //语音评测录音发音
            if(errCode == 2){ //音频文件丢失
                $(pubArgu.listenVoiceObj).addClass('hidden');
            }
        }
        else {
            //
        }

        if(message) alert(message);
        pubArgu.listenVoiceObj = null;
    }
 }

 /* 重绘当前webview
 */
 function refreshWebView(){
    // console.log("refreshWebView!!!");
    try{ dictcn.refreshWebView(); }catch(e){}
 }

/* 弹出提示框
 * 方法参数：
 * {
 * "message": "" //Toast消息内容
 * }
 */
 function showToast(message){
    try{ dictcn.showToast(JSON.stringify({'message': message})); }catch(e){}
 }

 /* 下载图片接口
 * requestImgPath方法参数：
 * {
 * "data": [{
 * "name": "" //图片name
 * "maxWidth": "320" //图片最大宽度(""空字符串代表没有)
 * "maxHeight": "" //图片最大高度(""空字符串代表没有)
 * },{},{},...],
 * "successCallback":"onRequestImgPathSuccess",         //成功回调函数
 * "failedCallback":"onRequestImgPathFailed",         //失败回调函数
 * }
 * onRequestImgPathSuccess方法参数：
 * {
 * "name": "" //图片name
 * "path": "" //图片路径
 * }
 * onRequestImgPathFailed方法参数：
 * {
 * "name": "" //图片name
 * }
 */
 function requestImgPath(jsonData){
    jsonData = parseJson(jsonData);
    if($.isArray(jsonData)){
        var jsonArray = [];
        for(var i=0,len=jsonData.length; i<len; i++){
            var val = jsonData[i];
            var name = val.name || "";
            var maxWidth = val.maxWidth ? val.maxWidth+"" : "";
            var maxHeight = val.maxHeight ? val.maxHeight+"" : "";
            if(name) jsonArray.push({"name":name, "maxWidth":maxWidth, "maxHeight":maxHeight});
        }
        // console.log(jsonArray)
        try{ dictcn.requestImgPath(JSON.stringify({"data":jsonArray, "successCallback": "onRequestImgPathSuccess", "failedCallback":"onRequestImgPathFailed"})); }catch(e){}
        // setTimeout(function(){
            // onRequestImgPathSuccess({"name":jsonData[0].name, "path":"./testAsset/"+jsonData[0].name});
            // onRequestImgPathFailed({"name":jsonData[0].name});
        // },2000);
    }
 }
 //请求图片成功回调函数
 function onRequestImgPathSuccess(jsonData){
    jsonData = parseJson(jsonData);
    var name = jsonData.name || "";
    var path = jsonData.path || "";
    if(name){
        var $img = $('img').filter("[name='"+ name +"']");
        if($img.length){
            $img.attr("src", path).removeClass("fail").addClass("success");
            setTimeout(function(){
                if($img.is(":visible")) $.commFun.resizeSwiper($img);
            },500);
        }
    }
 }
 //请求图片失败回调函数
 function onRequestImgPathFailed(jsonData){
    jsonData = parseJson(jsonData);
    var name = jsonData.name || "";
    if(name){
        var $img = $('img').filter("[name='"+ name +"']");
        if($img.length){
            $img.attr("src", _resource_+"/images/default_fail.png").addClass("fail");
        }
    }
 }




/* 查看大图方法
 * viewBigImg方法参数：
 * {
 * "name": ["","",...] //当前面板中图片name数组
 * "showName": "" //标记显示数组中的哪个图片
 * }
 */
 function viewBigImg(jsonData){
    jsonData = parseJson(jsonData);
    var name = jsonData.name || "";
    var showName = jsonData.showName || "";
    // console.log("name: "+name+ " / showName: "+ showName)
    try{ dictcn.viewBigImg(JSON.stringify({'name': name, 'showName': showName, "successCallback": "onViewBigImgSuccess"})); }catch(e){}
 }
 //成功回调函数
 function onViewBigImgSuccess(){
    //更新加载失败的图片链接
    var arr = [];
    $('.img img.fail').each(function(){
        var $this = $(this);
        arr.push({"name": $this.attr("name")});
    });
    if(arr.length) requestImgPath(arr);
 }


 /* 开放给native接口：页面退入后台后冲突处理方法 pageSleep：
 */
function pageSleep(){
    if(window.clickConflictTest) clickConflictTest();
}


// var jsonDD = {"uwid": "1192362130", "scbStatus":{"1192772106":1}, "htmlText": "\t<div class=\"addStar\"></div>\n\t\t<div class=\"pron\" uwid=\"1192362130\"><span class=\"playSound\" name=\"59964.mp3\" lang=\"b\"></span></div>\n\t\t\t\t\t\t\t\t<div class=\"sense sense1\">\n\t\t<p class=\"pos\"><fullname subuwid='1192910000' index='[5]'></fullname></p>\t\t<p class=\"sensedef\"><pgrclr>[take</pgrclr> <pgrclr> away from sth.]</pgrclr></p>\t\t\t\t\t\t<div class=\"cont cont1\">\n\t\t\t\t\t\t<p class=\"contdef\"><trclr><chs>减少</chs></trclr> <coclr>success, </coclr><coclr>merits</coclr></p>\t\t\t\t\t\t<div class=\"exampleModel\">\n\t\t\t\t\t\t\t\t<p class=\"exampleSen\"><span class=\"exa-word\">that doesn't take anything away from his achievement</span><span class=\"exa-def\"><chs>那丝毫不能贬低他的成绩</chs></span><span class=\"exampleIcon\" uwid=\"1192297320\"><span class=\"playSound\" name=\"d722e462212c21b362fe74bf691a6548.mp3\" lang=\"b\"></span><span class=\"addStar\" parentuwid=\"1192362130\" keypath=\"body.0.sense.0.cont.0.example.0\"></span></span></p>\n\t\t\t</div>\t\t</div>\n\t\t\t</div>\n\t\t\n"};